<template>
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-12 col-lg-8">
                <div class="status" v-show="gameOver"><img :src="gameOver"></div>
                <div class="centre">
                    <div class="maze-holder">
                        <div class="loader" v-show="loader"></div>
                        <div class="maze-perspective">

                            <div class="maze" v-if="cells">
                                <div v-for="(row, i) in cells" class="cells-row" :data-id="i">
                                    <cell 
                                        v-for="(cell, j) in cells[i]"
                                        :key="cell.id"
                                        :i="i"
                                        :j="j"
                                        :data-id="j"
                                        :data-index="cell.id"
                                    >

                                    </cell>
                                </div>
                            </div>

                        </div>
                    </div>
                </div>
            </div>
            <div class="col-sm-12 col-lg-4 controls">
                <h1>Ponyville Maps</h1>
                <button class="btn" v-on:click="getNewMaze" v-bind:class="{disabled: !isLoading}">Get New Maze</button>
                <br />
                <button class="btn full" v-on:click="walkTheWalk" v-bind:class="{disabled: !isLoading || !hasSolution}">Walk to the Exit</button>
            </div>

        </div>
    </div>
</template>

<script>

import { mapGetters, mapActions } from 'vuex';
import Vue from 'vue';
import axios from 'axios';
import Cell from './Cell.vue';

export default {
    name: 'App',
    components: {
        Cell
    },
    computed: {
        ...mapGetters([
            'width',
            'height',
            'cells',
            'loader',
            'solution',
            'gameOver'
        ]),
    },
    methods: {
        isLoading: function () {
            return this.loader;
        },
        hasSolution: function () {
            return this.solution;
        },
        getNewMaze: function () {
            if (this.loader) {
                return false;
            }
            this.$store.dispatch('newMaze');
        },
        walkTheWalk: function () {
            if (this.loader || !this.hasSolution) {
                return false;
            }
            this.$store.dispatch('walk');
        }
    },
}
</script>